program GrafFce;

{
  Kresleni grafu funkce jedne realne promenne,
  zapoctovy program Programovani I @ MFF.CUNI.CZ
  vytvoril: Jan Raszyk (I/Y-41) jan.raszyk@seznam.cz
}

uses
  Crt,
  Kresli,
  Aritmet,
  Strings,
  Graph;

const
  CESTAKEGRAFICE = '..';

var
  bExit: Boolean; { konec programu }
  fce: funkce;    { funkce zadana uzivatelem }

procedure ZobrazHelp;
{ precte a vypise soubor help.txt }
var f: Text;
s: string;
begin
  assign(f, 'help.txt');
  reset(f);
  while not eof(f) do begin
    readln(f,s);
    writeln(s);
  end;
end;

procedure NastavPriblizeni;
{ ziska od uzivatele hodnotu pozadovaneho priblizeni }
var z: integer;
begin
  writeln('Zadejte priblizeni z (1-',MAXZOOM,'); jeden pixel obrazovky bude mit velikost 1/z;');
  writeln('Standardni hodnota: 32');
  readln(z);
  if (z > 0) and (z <= MAXZOOM) then priblizeni := z;
end;

procedure NactiPredpis;
{ zobrazi hlavicku programu a napovedu a nacte predpis funkce ze vstupu }
begin
  ClrScr; textcolor(15);
  writeln('Kresleni grafu funkci, made by Jan Raszyk, jan.raszyk@seznam.cz');
  textcolor(7);

  GotoXY(1,10);
  ZobrazHelp;

  GotoXY(1,2);
  writeln; writeln('Zadejte predpis pro funkci f(x).');
  writeln('Pokud chcete skoncit, stisknete pouze Enter. Zadejte ''z'' pro zmenu priblizeni.');
  textcolor(15);
  write('f(x):=');
  readln(fce.sPredpis);
  if fce.sPredpis[0] = 'z' then begin
    NastavPriblizeni;
    NactiPredpis
  end else
  { pokud uzivatel nic nezadal, program konci }
  bExit := strlen(fce.sPredpis) = 0;
end; { of NactiPredpis }

procedure Vykresli(var fce: funkce);
{ projde spojovy seznam bodu funkce a spoji je carami }
var p,q: pzobrazeni;
  x1, y1, x2, y2: real;
begin
  p := fce.pZobr;
  x1 := p^.x; y1 := p^.y;
  while p <> nil do begin
    x2 := p^.x; y2 := p^.y;
    Caru(x1,y1,x2,y2);
    { koncovy bod se stava pocatecnim bodem dalsi cary }
    x1 := x2; y1 := y2;
    p := p^.dalsi;
  end
end;

procedure Zobraz;
{ inicializuje zobrazovaci engine a preda rizeni funkci Kresli }
var
  grDriver, grMode, ErrCode: Integer;
begin
  grDriver := Detect; { detekce nejlepsiho mozneho grafickeho rezimu }
  InitGraph(grDriver, grMode,CESTAKEGRAFICE); { inicializace grafickeho engine }
  ErrCode := GraphResult;
  if ErrCode = grOk then begin
    InicPlochu;
    Vykresli(fce);
    { funkce zustane vykreslena az do stisknuti nejake klavesy }
    repeat until KeyPressed; readkey;
    CloseGraph;
  end else begin
    writeln('Nepodarilo se inicalizovat graficky engine.');
    bExit := True;
    readln
  end
end; { of Zobraz }

procedure Predvypocty;
begin
  { rozdeleni predpisu funkce na podvyrazy - cisla a operace }
  Tokenize(fce);
  { naplneni spojoveho seznamu bodu prubehu funkce }
  ZiskejPrubeh(fce,-320/PRIBLIZENI,320/PRIBLIZENI);
end;

begin { of program Graffce }
  repeat
    NactiPredpis;
    if bExit then Exit;
    Predvypocty;
    Zobraz;
  until bExit; { nebylo-li vyvolano ukonceni programu, jdeme zpet na zacatek }
end.
